/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.sing.point.wrapper;

import org.apache.commons.lang3.ObjectUtils;
import org.springblade.common.utils.SpringContextHolder;
import org.springblade.core.mp.support.BaseEntityWrapper;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.core.tool.utils.ObjectUtil;
import org.springblade.core.tool.utils.StringUtil;
import org.springblade.sing.active.entity.ActiveProductRecord;
import org.springblade.sing.active.service.IActiveProductRecordService;
import org.springblade.sing.goods.entity.HelpGoods;
import org.springblade.sing.goods.service.IHelpGoodsService;
import org.springblade.sing.point.entity.PointRecord;
import org.springblade.sing.point.vo.PointRecordVO;
import org.springblade.sing.user.entity.LoginUser;
import org.springblade.sing.user.service.ILoginUserService;

import java.util.Objects;

/**
 * 积分兑换记录表包装类,返回视图层所需的字段
 *
 * @author BladeX
 * @since 2021-11-09
 */
public class PointRecordWrapper extends BaseEntityWrapper<PointRecord, PointRecordVO>  {

	private IActiveProductRecordService activeProductRecordService;
	private IHelpGoodsService helpGoodsService;
	private final static ILoginUserService loginUserService = SpringContextHolder.getBean(ILoginUserService.class);

	public PointRecordWrapper(IActiveProductRecordService activeProductRecordService, IHelpGoodsService helpGoodsService) {
		this.activeProductRecordService = activeProductRecordService;
		this.helpGoodsService = helpGoodsService;
	}

	public PointRecordWrapper() {

	}

	public static PointRecordWrapper build() {
		return new PointRecordWrapper();
 	}

	public static PointRecordWrapper build(IActiveProductRecordService activeProductRecordService, IHelpGoodsService helpGoodsService) {
		return new PointRecordWrapper(activeProductRecordService,helpGoodsService);
	}

	@Override
	public PointRecordVO entityVO(PointRecord pointRecord) {
		PointRecordVO pointRecordVO = Objects.requireNonNull(BeanUtil.copy(pointRecord, PointRecordVO.class));

		if (activeProductRecordService != null && helpGoodsService != null){
			ActiveProductRecord activeProductRecord = activeProductRecordService.getById(pointRecordVO.getActiveProductId());
			if (ObjectUtil.isNotEmpty(activeProductRecord)){
				pointRecordVO.setActiveProductName(activeProductRecord.getTitle());
			}

			HelpGoods helpGoods = helpGoodsService.getById(pointRecordVO.getHelpGoodsId());
			if (ObjectUtil.isNotEmpty(helpGoods)){
				pointRecordVO.setHelpGoodsName(helpGoods.getName());
			}
		}
		//User createUser = UserCache.getUser(pointRecord.getCreateUser());
		//User updateUser = UserCache.getUser(pointRecord.getUpdateUser());
		//pointRecordVO.setCreateUserName(createUser.getName());
		//pointRecordVO.setUpdateUserName(updateUser.getName());

		LoginUser loginUser = loginUserService.getById(pointRecordVO.getUserId());
		if(ObjectUtils.isNotEmpty(loginUser)){
			pointRecordVO.setUserName(loginUser.getNickName());
		}

		return pointRecordVO;
	}

}
